package com.manatee.manateewangcai.controller;

import com.alibaba.fastjson.JSONObject;
import com.manatee.lowcode.web.manager.CustomizeModuleManager;
import com.manatee.process.constant.ProcessConstant;
import com.manatee.process.domain.ProcessContent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created by ziyue on 2018/6/2.
 */
@Controller
@RequestMapping("/biz/custom")
public class ModularityCustomController {

    @Autowired
    private CustomizeModuleManager customizeModuleManager;

    //定制返回结构
    public JSONObject handleResult(JSONObject result){
        result = result.getJSONObject("data");
        return result;
    }

    @CrossOrigin(origins = "*")
    @RequestMapping(path = "/modularity/project{projectId}/{code}", method = RequestMethod.GET)
    @ResponseBody
    public JSONObject doModularityGet(HttpServletRequest request, HttpServletResponse response,
                                      @PathVariable Long projectId,
                                      @PathVariable String code) {
        ProcessContent content = new ProcessContent();
        initParam(content,request);
        content.putTempContent(ProcessConstant.Key.CODE, code);
        content.putTempContent(ProcessConstant.Key.PROJECT_ID, projectId);
        JSONObject result = customizeModuleManager.customize(request,content);
        result = handleResult(result);
        boolean committed = response.isCommitted();
        return committed?null:result;
    }

    @CrossOrigin(origins = "*")
    @RequestMapping(path = "/modularity/project{projectId}/{code}", method = RequestMethod.POST)
    @ResponseBody
    public JSONObject doModularityPost(HttpServletRequest request, HttpServletResponse response,
                                       @RequestBody(required = false) JSONObject data,
                                       @PathVariable Long projectId,
                                       @PathVariable String code) {
        ProcessContent content = new ProcessContent();
        initParam(content,request);
        content.putRequest(data);
        content.putTempContent(ProcessConstant.Key.CODE, code);
        content.putTempContent(ProcessConstant.Key.PROJECT_ID, projectId);
        JSONObject result = customizeModuleManager.customize(request,content);
        result = handleResult(result);
        boolean committed = response.isCommitted();
        return committed?null:result;
    }



    protected void initParam(ProcessContent content, HttpServletRequest request){
//        content.putTempContent("userId",userId);
    }

}
